/*
 * thermometer.c
 *
 * Created: 2011-07-31 17:57:14
 *  Author: Karol
 */ 


#include "m16_board.h"
#include <avr/pgmspace.h>

#define DS_PORTPINS_S PC0S

#include "ds18b20.h"

static const prog_char S_temp[] = "Temp:";
#define temp_addr (sizeof(S_temp)-1)

/*                                   0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f /16 */
static const prog_uint8_t fracs[] = {0, 1, 1, 2, 3, 3, 4, 4, 5, 6, 6, 7, 8, 8, 9, 9};

static void write_temp (int16_t temp)
{
	uint8_t frac;
	if (temp < 0)
	{
		LCD_data('-');
		temp = -temp;
	}
	else
	{
		LCD_data(' ');
	}
	LCD_number(temp >> 4);
	LCD_data('.');
	frac = pgm_read_byte(fracs + (temp & 0x0f));
	LCD_data(frac + '0');
	LCD_data(0xDF);
	LCD_data('C');
	
}
int main(void)
{
	int16_t temp;
	LCD_init();
	LCD_config();
	LCD_clear();
	LCD_goto(0);
	LCD_write_text_P(S_temp);
	OUTPUT(PB0S);
	while (1)
	{
		ds_ask_temp();
		HIGH(PB0S);
		_delay_ms(DS_MAX_CONV_TIME_MS);
		LOW(PB0S);
		
		LCD_goto(temp_addr);
		temp = ds_read_temp_crc();
		if (DS_TEMP_OK(temp))
		{
			write_temp(temp);
		}			
		else
		{
			LCD_write_text_P(PSTR("     ?"));
		}
		LCD_goto(0x40);
		LCD_hex(temp>> 8);
		LCD_hex(temp & 0xff);
	}		
		
    
}
